#include "hardware.h"

extern unsigned char videomem[24*4];

void intro( void ) {
    int x,y, dx,dy;
    int x2,y2, dx2,dy2;
    int x3,y3, dx3,dy3;
    int i,o;
    int l, dl;
    int cont = 1;

    //clear videomem and draw border
    videomem[0] = videomem[1] = videomem[2] = videomem[3] = 0xff;
    for( y = 1; y<24; y++) {
        LPM0; //vsync to build up the screen slowly..
        LPM0; //vsync to build up the screen slowly..
        x = (y<<2);
        videomem[x  ] = 0x01;
        videomem[x+1] = 0;
        videomem[x+2] = 0;
        videomem[x+3] = 0x80;
        if( (~P1IN & FIRE1) != 0 || (~P2IN & FIRE2) != 0 ) { cont = 0; break; }
    }

    if( cont ) {
        LPM0; //vsync to buld up the screen slowly..
        videomem[92] = videomem[93] = videomem[94] = videomem[95] = 0xff;


        x = y = dx = dy = 1;

        x2 = 4;
        y2 = 1;
        dx2 = -1;
        dy2 = 1;

        x3 = 16;
        y3 = 10;
        dx3 = dy3 = -1;

        i = 0;
        l = 0;
        dl = 1;
    }

    while(cont) {
        LPM0;		//sync with vertical refresh
        LPM0;
        LPM0;
        i++;
        P2OUT = 0xff;
        switch(i) {
            case 5:
                //line, slowest
                o = 4*l;
                videomem[o  ] = 0x01;
                videomem[o+1] = 0x00;
                videomem[o+2] = 0x00;
                videomem[o+3] = 0x80;
                l += dl;
                if( l<1 || l>16 ) dl = -dl;
                i = 0;
            case 4:
            case 1:
                //pixel 3, slowest
                videomem[y*4+(3-(x>>3))] &= ~(0x80>>(x&7));	//clear dot
                x += dx;
                y += dy;
                if( x >= 30 || x <= 1 ) dx = -dx;
                if( y >= 22 || y <= 1 ) dy = -dy;
                if( y <= (l+1) ) dy = 1;
                videomem[y*4+(3-(x>>3))] |= 0x80>>(x&7);	//set dot

            case 2:
                //pixel 1, slow
                videomem[y3*4+(3-(x3>>3))] &= ~(0x80>>(x3&7));	//clear dot
                x3 += dx3;
                y3 += dy3;
                if( x3 >= 30 || x3 <= 1 ) dx3 = -dx3;
                if( y3 >= 22 || y3 <= 1 ) dy3 = -dy3;
                if( y3 <= (l+1) ) dy3 = 1;
                videomem[y3*4+(3-(x3>>3))] |= 0x80>>(x3&7);	//set dot
            default:
                //pixel 2, fast
                videomem[y2*4+(3-(x2>>3))] &= ~(0x80>>(x2&7));	//clear dot
                x2 += dx2;
                y2 += dy2;
                if( x2 >= 30 || x2 <= 1 ) dx2 = -dx2;
                if( y2 >= 22 || y2 <= 1 ) dy2 = -dy2;
                if( y2 <= (l+1) ) dy2 = 1;
                videomem[y2*4+(3-(x2>>3))] |= 0x80>>(x2&7);	//set dot

                //draw line everytime
                o = 4*l;
                videomem[o] = videomem[o+1] = videomem[o+2] = videomem[o+3] = 0xff;
        }

    P2OUT &= ~0xff;
    if( (~P1IN & FIRE1) != 0 || (~P2IN & FIRE2) != 0 ) break;
    }
}
