#ifndef HARDWARE_H
#define HARDWARE_H

#include <io.h>
#include <signal.h>
#include <iomacros.h>

/*  P1 & P2 init */
#define P1OUT_INIT  BIT0|BIT1                   // Init Output data of port1
#define P2OUT_INIT  0                           // Init Output data of port2

#define P1DIR_INIT  BIT0|BIT1|BIT2              // Init of Port1 Data-Direction Reg (Out=1 / Inp=0)

#define P2DIR_INIT  BIT5                        // Init of Port2 Data-Direction Reg (Out=1 / Inp=0)

#define P1SEL_INIT  BIT1|BIT2                   // P1-Modules:
#define P2SEL_INIT  0                           // P2-Modules:

#define JOYMASK1        0xf8
#define JOYMASK2        0x1f

#define FIRE1           0x08
#define UP1             0x10
#define DOWN1           0x20
#define LEFT1           0x40
#define RIGHT1          0x80

#define FIRE2           0x10
#define UP2             0x08
#define DOWN2           0x04
#define LEFT2           0x02
#define RIGHT2          0x01

#endif //HARDWARE_H
