
#include "hardware.h"

extern void game( void );

volatile unsigned int state;
unsigned char videomem[24*4];   //32x24 pixels => 32/8*24 bytes
unsigned short freq;
unsigned short play;
unsigned short sde;
unsigned short line;


interrupt (PORT1_VECTOR) INT_P1(void) {
    //acknowledge interrupts (caution! clr is not appropriate when multiple irqs are enabled)
    P1IFG = 0;
}

interrupt (PORT2_VECTOR) INT_P2(void) {
    //acknowledge interrupts (caution! clr is not appropriate when multiple irqs are enabled)
    P2IFG = 0;
}


interrupt (NOVECTOR) INT_TimerA_CCR1(void) {}

interrupt (NOVECTOR) INT_TimerA_CCR2(void) {}
    
interrupt (NOVECTOR) INT_TimerA_TAOVER(void) {}


/* interrupt (TIMERA0_VECTOR) __attribute__ ((naked)) INT_TimerA_CCR0(void) {
 *     asm(".extern ta0Int");
 *     asm("br #ta0Int");
 * }
 */


int main(void) {
    int i;
    WDTCTL = WDTPW + WDTHOLD; // Stop watchdog timer
    
    P1OUT  = P1OUT_INIT;                    // Init output data of port1
    P2OUT  = P2OUT_INIT;                    // Init output data of port2
    
    P1DIR  = P1DIR_INIT;                    // Init port direction register of port1
    P2DIR  = P2DIR_INIT;                    // Init port direction register of port2
    
    P1SEL  = P1SEL_INIT;                    // Select port or module -function on port1
    P2SEL  = P2SEL_INIT;                    // Select port or module -function on port2
    
    P1IE = 0;
    P2IE = 0;
    
    //Clock init
    BCSCTL1 = XTS;                          // select HF oszi
    do {
        IFG1 &= ~OFIFG;
        BCSCTL2 = SELM0+SELM1+DIVS1;         // select XT2CLK, smclk div 4
        BCSCTL2 |= SELS;                     // select XT2CLK
    }
    while ((IFG1 & OFIFG) != 0);
    IE1 |= OFIE;

    TACTL  = TASSEL0+TACLR;                 // Timer init ACLK
    CCR0   = 512;                           // 64 us
    CCTL0  = CCIE|OUT;                      // video line interrupt
    CCTL1  = 0;
    CCTL2  = 0;
//   CCTL1  = OUTMOD2;                       // set toggle mode
    TACTL  |= MC0;                          // Start timer up mode
    
    state = 0;
    
    //clearscreen
    for( i = 24*4-1; i>=0; i--) {
            videomem[i] = 0;
    }

    _EINT();             // enable interrupts

    while(1) {
        game();
    }
}
